// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rmf_workcell_msgs:msg/WorkcellConfiguration.idl
// generated code does not contain a copyright notice

#ifndef RMF_WORKCELL_MSGS__MSG__DETAIL__WORKCELL_CONFIGURATION__TRAITS_HPP_
#define RMF_WORKCELL_MSGS__MSG__DETAIL__WORKCELL_CONFIGURATION__TRAITS_HPP_

#include "rmf_workcell_msgs/msg/detail/workcell_configuration__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'time'
#include "builtin_interfaces/msg/detail/time__traits.hpp"
// Member 'assets'
#include "rmf_workcell_msgs/msg/detail/asset__traits.hpp"
// Member 'traits'
#include "rmf_workcell_msgs/msg/detail/trait__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rmf_workcell_msgs::msg::WorkcellConfiguration & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time:\n";
    to_yaml(msg.time, out, indentation + 2);
  }

  // member: guid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "guid: ";
    value_to_yaml(msg.guid, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: assets
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.assets.size() == 0) {
      out << "assets: []\n";
    } else {
      out << "assets:\n";
      for (auto item : msg.assets) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: traits
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.traits.size() == 0) {
      out << "traits: []\n";
    } else {
      out << "traits:\n";
      for (auto item : msg.traits) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rmf_workcell_msgs::msg::WorkcellConfiguration & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rmf_workcell_msgs::msg::WorkcellConfiguration>()
{
  return "rmf_workcell_msgs::msg::WorkcellConfiguration";
}

template<>
inline const char * name<rmf_workcell_msgs::msg::WorkcellConfiguration>()
{
  return "rmf_workcell_msgs/msg/WorkcellConfiguration";
}

template<>
struct has_fixed_size<rmf_workcell_msgs::msg::WorkcellConfiguration>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_workcell_msgs::msg::WorkcellConfiguration>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_workcell_msgs::msg::WorkcellConfiguration>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RMF_WORKCELL_MSGS__MSG__DETAIL__WORKCELL_CONFIGURATION__TRAITS_HPP_
